;  Convert.asm
; the following 2 lines must be before any other non-comment lines 
;  in the file and be in this order
        .586          ; this order of .X86 and .MODEL gives
        .MODEL FLAT,C ; the desired result for 32bit flatland
                    ; and  the C calling convention as a default
                    ; you can use other calling conventions if 
                    ; desired, but all must match...

; Next, prototype the function(s), just like you'd do with C++ or C
 
; Convert, copy, clip, float -> SHORT 
CvtCpyCfs      PROTO C dest:DWORD,src:DWORD,amount:DWORD 
        
; end of prototypes
; some people put the prototypes into a seperate include file and 
; include it here, usually using .inc for the file extension -- 
; handy if you have modules that call functions in one another -- 
; works just like C does.

        .DATA ; make a data section, but it's not needed in this 
              ;example

; You can put initialized or uninitialized data here for use by 
; this module, and even declare it public so others can see it as 
; well, such as the caller, or any other modules that include the 
; correct externs.  See the Masm reference for more on this.  
; Not generally needed if all you're  doing is speeding up some 
; C code.
           
        .CODE ; tell the assembler the following is code 
;****************************************
CvtCpyCfs   PROC C USES edi esi, dest:DWORD,src:DWORD,amount:DWORD
            LOCAL clipped:DWORD
            pushad	  ; easy&quick to be safe, so why not?
            mov edi,dest  ; get pointers to dest 
            mov esi,src   ; and source buffers
            mov ecx,amount; and number of conversions to do
            xor ebx,ebx   ; get 0 quickly, with no xtra mem access 
            mov clipped,ebx   ; start with no clips reported
            mov edx,8dfffc00h ; magic # for 32767, could be _any_ 
            .REPEAT	      ; =='for' loop, using ecx downcount 
            mov eax,[esi]     ; get # to convert 
            shl eax,1         ; put sign in carry
            cmp eax,edx       ; compare to magic #
            jnbe fsclp        ; if not too big,fall thru, else clip
            fld REAL4 PTR [esi]; else just use fpu to convert 
            fistp WORD PTR [edi] ; this to a short integer
fscont:     add esi,4         ; sizeof (float) added to ptr
            add edi,2	      ; sizeof (short) added to dest ptr
            .UNTILCXZ         ; end of repeat-loop directive
            popad             ; restore all data registers
            mov eax,clipped   ; now return a useful value, why not?	
            ret               ; note return value loaded AFTER 
                              ; the register restore

;**** actual clipping here, speed is not as important as that of 
;**** main loop, since clipping should be rare if the output audio
;**** data is to be usable anyway.

fsclp:      inc clipped   ; count the clips in a local, named, var
            mov eax,[esi] ; get orig # back from cache 
            or eax,eax    ; actually load the flags from eax
            js fsclpm     ; if sign bit set, it was negative
            mov WORD PTR [edi],32767 ; else positive clip 
            jmp fscont    ; go back to loop
fsclpm:     mov WORD PTR [edi],-32767 ; clip symetrically for audio
            jmp fscont    ; continue with more conversions
CvtCpyCfs   ENDP          ; end of procedure
            END           ; of file, must have one of these 
                          ; after all your code!


