// Listing 1
     
#include <iostream.h>
     
const int BSIZE=1024; // pick a convenient size 
class ResourceBuffer: public streambuf
{
    HGLOBAL resource_handle; // handle to resource
    char huge* data;         // pointer to resource data in memory 
    char buff[BSIZE];        // resource I/O buffer
    DWORD size;              // size of resource data
public:
    ResourceBuffer(HMODULE module, HRSRC resource_data); 
    ~ResourceBuffer();
    int underflow();
};
     
ResourceBuffer::ResourceBuffer(HMODULE module, HRSRC resource_data)
    :streambuf(buff, BSIZE),size(0),data(0)
{
    setg(buff, &buff[BSIZE], &buff[BSIZE]); // set buffer to empty 
    // get resource handle
    resource_handle = LoadResource(module, resource_data); 
    if (resource_handle){
        // get total size of resource data
        size = SizeofResource(module, resource_data); 
        // get a pointer to the data
        data = (char huge*)LockResource(resource_handle);
    }
}
     
ResourceBuffer::~ResourceBuffer()
{
    // free resource
    if (resource_handle){
        UnlockResource(resource_handle);
        FreeResource(resource_handle);
    }
}
     
// copy resource data to I/O buffer
// (this is where the work takes place) 

int ResourceBuffer::underflow()
{
    if (size == 0)
        return EOF; // done
    int s = BSIZE;
    if (s > size) s = (int)size; // size of last chunk 
    size -= s; // decrement total
    for (int i = 0; s-- > 0; i++)
        buff[i] = *data++; // copy up to BSIZE bytes from resource
    setg(buff, buff, &buff[BSIZE]); // indicate buffer is full 
    return sgetc();
}
     
